"use strict";

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.computeBlocks = undefined;

var _bluebirdLst;

function _load_bluebirdLst() {
    return _bluebirdLst = require("bluebird-lst");
}

// main exe not changed if unsigned, but if signed - each sign noticeably changes the file
let computeBlocks = exports.computeBlocks = (() => {
    var _ref = (0, (_bluebirdLst || _load_bluebirdLst()).coroutine)(function* (inputFile) {
        const fd = yield (0, (_fsExtraP || _load_fsExtraP()).open)(inputFile, "r");
        const chunkSize = 64 * 1024;
        const buffer = Buffer.allocUnsafe(chunkSize);
        const stat = yield (0, (_fsExtraP || _load_fsExtraP()).fstat)(fd);
        const size = stat.size;
        const blocks = [];
        for (let offset = 0; offset < size; offset += chunkSize) {
            const actualChunkSize = Math.min(size - offset, chunkSize);
            yield (0, (_fsExtraP || _load_fsExtraP()).read)(fd, buffer, 0, actualChunkSize, offset);
            const hash = (0, (_crypto || _load_crypto()).createHash)("sha256");
            hash.update(actualChunkSize === chunkSize ? buffer : buffer.slice(0, actualChunkSize));
            blocks.push(hash.digest("base64"));
        }
        return blocks;
    });

    return function computeBlocks(_x) {
        return _ref.apply(this, arguments);
    };
})();
//# sourceMappingURL=blockMap.js.map


var _crypto;

function _load_crypto() {
    return _crypto = require("crypto");
}

var _fsExtraP;

function _load_fsExtraP() {
    return _fsExtraP = require("fs-extra-p");
}